#include "lfpaillier.h"
#include "fasta_nucleotide.hpp"
#include "sais.hpp"
#include "vbwt.hpp"
#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>
#include <string.h>
#include <openssl/evp.h>
#include <openssl/cmac.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <errno.h>

#define BLOCK_SIZE 16
#define RANDOM_SOURCE "/dev/urandom"
#define MODULUS_SIZE 1024

#define MIN(X, Y)  ((X) < (Y) ? (X) : (Y))

#define CHECK_MALLOC(ptr) if(ptr == NULL && errno == ENOMEM) {printf("out of memory \n");exit(-1);} 

typedef struct key{
	unsigned char enc_key[BLOCK_SIZE];
	djcs_public_key *pk;
	djcs_private_key *sk;
	hcs_random *hr;
} key_tuple;

typedef struct data{
	mpz_t* BWT;
	unsigned long bwt_len;
	unsigned int bwt_depth;
	unsigned int bwt_entry_size;
	unsigned int sample_size;
	unsigned int sample_rate;
	unsigned int sa_sample_rate;
	unsigned int no_bits;
	unsigned int b_bwt;
	unsigned int b_sa;
	mpz_t *SA;
	unsigned int sa_len;
	unsigned int sa_depth;
	unsigned int sa_entry_size;
} dataset;

void byte_to_mpz(unsigned char* bytes,unsigned int len_bytes,mpz_t dest);
unsigned char* mpz_to_byte(mpz_t op, unsigned int num_digits);
