#ifndef LFPAILLIER_H
#define LFPAILLIER_H
#include <gmp.h>
#include <libhcs.h>
#include <stdlib.h>

void djcs_encrypt_with_length(djcs_public_key *pk,hcs_random *hr, mpz_t ctx, mpz_t plain, unsigned long s);
void djcs_decrypt_with_length(djcs_private_key *sk, mpz_t plain, mpz_t ctx, unsigned long s);
void djcs_hom_add_ptx(djcs_public_key *pk,mpz_t res, mpz_t op1, mpz_t plain,unsigned long s);
void djcs_hom_add(djcs_public_key *pk,mpz_t res, mpz_t op1, mpz_t op2,unsigned long s);
void djcs_hom_mul(djcs_public_key *pk,mpz_t res, mpz_t op1, mpz_t plain,unsigned long s);
void djcs_cleanup(djcs_public_key *pk,djcs_private_key *sk,hcs_random *hr);
void oblivious_selection(mpz_t dest, djcs_public_key *pk, mpz_t el1, mpz_t el2, mpz_t flipped_selector, mpz_t selector_bit, unsigned long s);
void oblivious_selection(mpz_t dest, djcs_public_key *pk, mpz_t el1, mpz_t el2, mpz_t selector_bit, unsigned long s);
void invert_bit(mpz_t flipped, djcs_public_key* pk, mpz_t bit, unsigned long s);
void homomorphic_dot_product(mpz_t dest, djcs_public_key *pk, mpz_t * results, mpz_t* trapdoor, unsigned long s, unsigned int b);

#endif
